***** File description **************************************************
*** File:        decrypt.s
***              (This is a part of Norbert Gb's PASSSAVE)
*** Platform:    HP48GX
*** Language:    System-RPL
*** Description: Input:
***                <2> char-str --- encrypted, compressed data
***                <1> char-str --- password
***              Output: 
***               <2'> ?        --- data from <2>
***               <1'> bool     --- is the password correct ?
***              
***              Decrypts <2> via LRD (md5lib) using key <1> and
***              uncompresses the result via 'bz1'. This is the
***              Sys-RPL version of the following:
***              
***              << IF LRD THEN "BZ" SWAP + bz1 END >>
***              
***              That ought to be the inverse of encrypt.s.
***              
*** Author:      Norbert Gb (goeb@mathematik.uni-kl.de)
*** Date:        02/2000
***
*** License/Disclaimer **************************************************
*** This program is free software; you can redistribute it and/or  modify
*** it under the terms of the GNU General Public License as published  by
*** the Free Software Foundation; either version 2, or (at  your  option)
*** any later version.
*** 
*** This program is distributed in the hope that it will be  useful,  but
*** WITHOUT  ANY  WARRANTY;  without  even  the   implied   warranty   of
*** MERCHANTABILITY or FITNESS FOR A  PARTICULAR  PURPOSE.  See  the  GNU
*** General Public License for more details.
*** 
*** You should have received a copy of the  GNU  General  Public  License
*** along  with  this  program;  if  not,  write  to  the  Free  Software
*** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
*** USA.
*************************************************************************

*  ( hxs  --> str )
ASSEMBLE
=DoRomptr EQU #02FEF
        NIBASC  /HPHP48-D/
RPL
:: 
    CK2NOLASTWD 
    CK&DISPATCH1 #00033 
    :: 
      ( LRD )
      #6F0 ONE
      #>ROMPTR
      DoRomptr

      ( return-values: [decrypted string]-[real indicating success] )
      %0<>
      DUP
      IT
      ::
        SWAP
	"BZ"
	SWAP
	&$

 	ID bz1
 	
 	SWAP
      ; 
    ;
;
