***** File description **************************************************
*** File:        dispStrings.s
***              (This is a part of Norbert Gb's PASSSAVE)
*** Platform:    HP48GX
*** Language:    System-RPL
*** Description: Input:
***                <2> list of strings
***                <1> bint
***              Output:
***                <2'> copy of <2>
***                <1'> copy of <1>
***              
***              Displays the strings in <2>, using a line each.
***              The <1>-th string is being marked as selected.
***              We use the areas DA1 & DA2(a-b) of the text-grob to display
***              the strings, i.e. everything but the menu.
***              If there are more strings than we can display, we ignore
***              the remaining ones; if <1> is out of range, no string is
***              marked.
***              
***              Programming note: The ordering of the arguments is due to
***              having some logic in function-arguments; the ordering <1>-<2>
***              could save two SWAPs.
***              
*** Author:      Norbert Gb (goeb@mathematik.uni-kl.de)
*** Date:        02/2000
***
*** License/Disclaimer **************************************************
*** This program is free software; you can redistribute it and/or  modify
*** it under the terms of the GNU General Public License as published  by
*** the Free Software Foundation; either version 2, or (at  your  option)
*** any later version.
*** 
*** This program is distributed in the hope that it will be  useful,  but
*** WITHOUT  ANY  WARRANTY;  without  even  the   implied   warranty   of
*** MERCHANTABILITY or FITNESS FOR A  PARTICULAR  PURPOSE.  See  the  GNU
*** General Public License for more details.
*** 
*** You should have received a copy of the  GNU  General  Public  License
*** along  with  this  program;  if  not,  write  to  the  Free  Software
*** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
*** USA.
*************************************************************************

*  ( hxs  --> str )
ASSEMBLE
        NIBASC  /HPHP48-D/
RPL
:: 
    CK2NOLASTWD 
    CK&DISPATCH1 #0051F 
    :: 
      ( how many strings shall we display? )
      SWAP 
      DUP
      LENCOMP
      SEVEN
      #MIN
      ( loop: Display the single strings: )
      #1+_ONE_DO (DO)
        ( stack: bint<1>-list<2> )
	OVER
	INDEX@
	#=
	ITE
	::
	  "*"
	;
	::
	  " "
	;
	( stack: <1>-<2>-[startingString - selected item?] )
	OVER
	INDEX@
	NTHCOMPDROP
	( stack: <1>-<2>-[startingString]-[itemString] )
	&$
	INDEX@
	DISPN
      LOOP
      
      ( stack <1>-<2> )
      SWAP
    ;
;
