***** File description **************************************************
*** File:        encrypt.s
***              (This is a part of Norbert Gb's PASSSAVE)
*** Platform:    HP48GX
*** Language:    System-RPL
*** Description: Input:
***                <2> list         --- the data
***                <1> char-string  --- the passwd
***              Output:
***                <1'> char-string --- encryption of <2>, using passwd <1>
***              
***              Compresses <2> using 'bz1' and encrypts the result
***              using LRE from the md5lib-library. It's the Sys-RPL-
***              version of the following:
***              
***              << SWAP bz1 0 CHR + 3 OVER SIZE SUB SWAP LRE >>
***              
***              This ought to be the opposite of decrypt.s
***              
*** Author:      Norbert Gb (goeb@mathematik.uni-kl.de)
*** Date:        02/2000
***
*** License/Disclaimer **************************************************
*** This program is free software; you can redistribute it and/or  modify
*** it under the terms of the GNU General Public License as published  by
*** the Free Software Foundation; either version 2, or (at  your  option)
*** any later version.
*** 
*** This program is distributed in the hope that it will be  useful,  but
*** WITHOUT  ANY  WARRANTY;  without  even  the   implied   warranty   of
*** MERCHANTABILITY or FITNESS FOR A  PARTICULAR  PURPOSE.  See  the  GNU
*** General Public License for more details.
*** 
*** You should have received a copy of the  GNU  General  Public  License
*** along  with  this  program;  if  not,  write  to  the  Free  Software
*** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
*** USA.
*************************************************************************

*  ( hxs  --> str )
ASSEMBLE
=DoRomptr EQU #02FEF
        NIBASC  /HPHP48-D/
RPL
:: 
    CK2NOLASTWD 
    CK&DISPATCH1 #00053 
    :: 
       SWAP
       ID bz1
       CHR_00
       CHR>$
       &$
       THREE
       OVERLEN$
       SUB$
       SWAP

       ( LRE )
       #6F0 ZERO
       #>ROMPTR
       DoRomptr 

    ;
;
