***** File description **************************************************
*** File:        getPasswd.s
***              (This is a part of Norbert Gb's PASSSAVE)
*** Platform:    HP48GX
*** Language:    System-RPL
*** Description: Input:
***                <1>  charString
***              Output: 
***                <1'> charString
***              
***              Prompts the user for his/her password and
***              puts it on the stack. 
***              
***              Prompt:
***                <1>
***                "Enter password:"
***              
*** Author:      Norbert Gb (goeb@mathematik.uni-kl.de)
*** Date:        02/2000
***
*** License/Disclaimer **************************************************
*** This program is free software; you can redistribute it and/or  modify
*** it under the terms of the GNU General Public License as published  by
*** the Free Software Foundation; either version 2, or (at  your  option)
*** any later version.
*** 
*** This program is distributed in the hope that it will be  useful,  but
*** WITHOUT  ANY  WARRANTY;  without  even  the   implied   warranty   of
*** MERCHANTABILITY or FITNESS FOR A  PARTICULAR  PURPOSE.  See  the  GNU
*** General Public License for more details.
*** 
*** You should have received a copy of the  GNU  General  Public  License
*** along  with  this  program;  if  not,  write  to  the  Free  Software
*** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
*** USA.
*************************************************************************

*  ( hxs  --> str )
ASSEMBLE
        NIBASC  /HPHP48-D/
RPL
:: 
    CK0NOLASTWD 
    ::
      ( prepare the display )
      ClrDA1IsStat
      RECLAIMDISP

      ( display prompt )
      BlankDA12
      DISPROW1
      "Enter Password:"
      DISPROW3
      " (Cancel clears input)"
      DISPROW4

      ( lock alpha-mode )
      LockAlpha

      ( create empty strings for storing the password and the asterisks )
      NULL$
      NULL$
     
      ( enter-loop )
      FLUSHKEYS
      BEGIN
        WaitForKey
	( stack: [result str.]-[asterisk str.]-[key]-[modifiers] )
	( check for ENTER )
	OVER
	TWENTYFIVE
	#=
	ITE
	:: ( user pressed RETURN )
	   3DROP ( dropping asterisk-str and key-code )
	   TRUE ( yes, we wanna quit the loop... )
	;
	::
	  ( user did not press ENTER ) 
	  ( stack: [result str.]-[asterisk str.]-[key]-[modifiers] )
	  ( check for CANCEL )
	  
	  OVER
	  FORTYFIVE
	  #=
	  ITE
	  ::
	    ( user pressed CANCEL )
	    4DROP
	    NULL$
	    DUPDUP
	    DISPROW6
	  ;
	  ::
	    ( ordinary key input --- neither ENTER nor CANCEL )
	    
	    ( make a character out of the keypress --- in a simple way, )
	    ( not the char printed on the key: multiply keycode and )
	    ( modifiers modulo 255d )
	    FORTYNINE
	    #* 
	    #+
	    DUP
	    BINT255d
	    #>
	    IT
	    ::
	      BINT255d
	      #-
	    ; 
	    ( convert to some one-char-string )
	    #>HXS
	    #>%
            DOCHR

	    ( stack: [result str.]-[asterisk str.]-[one-char-string] )
	    ( append the char to the result )
	    ROTSWAP
	    &$
	    SWAP
	    ( append an asterisk to the asterisk-string and show it )
	    "*"
	    &$
	    DUP
	    DISPROW6 
	  ;
	  FALSE ( do not quit the loop )
	;
      UNTIL
      
      ( stack: [password] )

      ( unlock the alpha-key )
      UnLockAlpha
      
    ;
;
